<template>
  <div class="Menu">
    <div :key="index" v-for="(icon, index) in icons">
      <Cell
        :ref="icon.name"
        :piece="icon.name"
        :styling="icon.styling"
        :isPlayerOne="icon.isPlayerOne"
        :xPosition="index"
        :yPosition="index"
        @handleClickedCell="handleClickedCell($event)"
      />
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import Cell from "./Cell.vue";
import { Component, Prop, Watch } from "vue-property-decorator";
import { PieceName, Styling, PieceInfo, Position } from "../models/pieceModels";
import { listOfPieces } from "../utilities/defaultPieceInfo";

@Component({
  components: {
    Cell
  }
})
export default class Menu extends Vue {
  @Prop() readonly playerTurn!: boolean;

  private icons: PieceInfo[] = listOfPieces;

  mounted() {
    this.updatePlayerTurn();
  }

  handleClickedCell(position: Position) {
    const { xPosition, yPosition } = position;
    if (
      this.icons.some(
        icon =>
          icon.name === this.icons[xPosition].name && icon.styling === Styling.MOVEMENT_HIGHLIGHT
      )
    ) {
      this.icons = this.icons.map(icon => ({ ...icon, styling: Styling.DEFAULT }));
      this.$emit("selectPiece", null);
    } else {
      this.icons = this.icons.map(icon => {
        if (icon.name === this.icons[xPosition].name) {
          return { ...icon, styling: Styling.MOVEMENT_HIGHLIGHT };
        }

        return { ...icon, styling: Styling.DEFAULT };
      });

      this.$emit("selectPiece", this.icons[xPosition].name);
    }
  }

  @Watch("playerTurn")
  updatePlayerTurn(): void {
    this.icons = this.icons.map(icon => ({ ...icon, isPlayerOne: this.playerTurn }));
  }
}
</script>

<style>
.Menu {
  margin-right: 1rem;
}
</style>
